"""The classic example.

Executes a simple transformation and prints the string result
"""

import Pyana

inputExampleXSL = r'''
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
    <xsl:output method="text"/>
    <xsl:template match="message"><xsl:value-of select="child::text()"/></xsl:template>
</xsl:stylesheet>
'''

inputExampleXML = r'''
<message>Hello World!</message>
'''

print Pyana.transform2String(source=inputExampleXML, style=inputExampleXSL)