from xml.dom.minidom import getDOMImplementation
import apsw
import re
import sys

global false, true
true = 1
false = 0

def getUserInfo(params, cursor, serverVars):

	print "___MDDB:getUserInfo"
	success = true
	# no params
	impl = getDOMImplementation()
	
	SQL = """
		SELECT
			uri, 
			name, 
			link, 
			description, 
			image, 
			pubKey, 
			tags, 
			hops
		FROM 
			tblInformerProfiles 
		WHERE
			uri = ( SELECT varValue FROM tblSystemVars WHERE varName ='userURI' LIMIT 1)
		;
	""" 
	print SQL
	
	try:	
		# yes, a for loop is dumb. There should be only one result.
		# but APSW gives it's cryptic apsw.MisuseError if you try to do a direct assignment.. sigh.
		for (uri, name, link, description, image, pubKey, tags, hops) in cursor.execute(SQL):
			newdoc = impl.createDocument(None, "results", None)
			results_element = newdoc.documentElement		

			informer_element = newdoc.createElement("informer")
			results_element.appendChild( informer_element )

			uri_element = newdoc.createElement("uri")
			uri_element.appendChild( newdoc.createTextNode(uri) )
			informer_element.appendChild( uri_element )
			name_element = newdoc.createElement("name")
			name_element.appendChild( newdoc.createTextNode(name) )
			informer_element.appendChild( name_element )
			i_link_element = newdoc.createElement("link")
			i_link_element.appendChild( newdoc.createTextNode(link) )
			informer_element.appendChild( i_link_element )
			i_description_element = newdoc.createElement("description")
			i_description_element.appendChild( newdoc.createTextNode(description) )
			informer_element.appendChild( i_description_element )
			image_element = newdoc.createElement("image")
			image_element.appendChild( newdoc.createTextNode(image) )
			informer_element.appendChild( image_element )
			tags_element = newdoc.createElement("tags")
			tags_element.appendChild( newdoc.createTextNode(tags) )
			informer_element.appendChild( tags_element )
			pubKey_element = newdoc.createElement("pubKey")
			pubKey_element.appendChild( newdoc.createTextNode(pubKey) )
			informer_element.appendChild( pubKey_element )
		print "___MDDB:it worked?"
	except apsw.MisuseError: #TODO: WTF is this non-error?
		print "___MDDB:apsw.MisuseError"
		pass
	except :
		print "___MDDB:Failed on SELECT of getUserInfo ", sys.exc_info()[0]
		newdoc = impl.createDocument(None, "failure", None)
		results_element = newdoc.documentElement		
	
	return newdoc.toxml()	

