from xml.dom.minidom import getDOMImplementation
import re, urllib
import apsw

global false, true
true = 1
false = 0

def myInformers(params, cursor, serverVars):
	print "___MDDB:my reports"
	showSQL = false;
	getAll = false;
	for (param,value) in params:
		if (param=="SQL"):
			showSQL = true
		if (param=="getAll"):
			getAll = true
			
	# setup our XML output
	impl = getDOMImplementation()
	newdoc = impl.createDocument(None, "results", None)
	results_element = newdoc.documentElement		
	
	reports_element = newdoc.createElement("reports")
	results_element.appendChild(reports_element)

	if not(getAll):
		whereText = "AND R.informer = '%s'" % (serverVars["userURI"])
	else:
		whereText = ""
		
	SQL = """
		SELECT 
			I.uri
			,I.name
			,I.link
			,I.description
			,I.image
			,I.tags
			,I.hops
			,R.scope
			,R.link
			,R.isInformerStatement
			,R.quality
			,R.date
			,R.description
			,R.tags
			,ID.visitDate
			,ID.modifiedDate
			,ID.failDate
			,ID.comment
		FROM
			tblReports R LEFT OUTER JOIN tblInformerProfiles I ON R.link = I.uri
			LEFT OUTER JOIN tblInformerDownload ID ON R.link = ID.informer
		WHERE
			R.isInformerStatement = 1
			%s
		ORDER BY
			I.hops		
			,R.date DESC
	"""  % (whereText)

	print SQL
	
	count = 0
	for (uri, \
		name, \
		i_link, \
		i_description, \
		image, \
		i_tags, \
		hops, \
		scope, \
		link, \
		isInformerStatement, \
		quality, \
		date, \
		description, \
		tags, \
		visitDate, \
		modifiedDate, \
		failDate, \
		comment ) \
	in cursor.execute(SQL):
		count += 1
		#print count
		
		# hack for older statements
		if not(link):
			link = scope
		
		# this is dumb. I wish I had javascript here.							
		uri=("", uri)[bool(uri)]
		name=("", name)[bool(name)]
		i_link=("", i_link)[bool(i_link)]
		i_description=("", i_description)[bool(i_description)]
		image=("", image)[bool(image)]
		i_tags=("", i_tags)[bool(i_tags)]
		hops=("", repr(hops))[bool(hops)]
		scope=("", scope)[bool(scope)]
		link=("", link)[bool(link)]
		isInformerStatement=("", isInformerStatement)[bool(isInformerStatement)]
		quality=("", quality)[bool(quality)]
		date=("", date)[bool(date)]
		description=("", description)[bool(description)]
		tags=("", tags)[bool(tags)]

		visitDate=("", visitDate)[bool(visitDate)]
		modifiedDate=("", modifiedDate)[bool(modifiedDate)]
		failDate=("", failDate)[bool(failDate)]
		comment=("", comment)[bool(comment)]

		report_element = newdoc.createElement("report")
		reports_element.appendChild( report_element )

		scope_element = newdoc.createElement("scope")
		scope_element.appendChild( newdoc.createTextNode(scope) )
		report_element.appendChild( scope_element )
		link_element = newdoc.createElement("link")
		link_element.appendChild( newdoc.createTextNode(link) )
		report_element.appendChild( link_element )
		isInformerStatement_element = newdoc.createElement("isInformerStatement")
		isInformerStatement_element.appendChild( newdoc.createTextNode(isInformerStatement) )
		report_element.appendChild( isInformerStatement_element )
		quality_element = newdoc.createElement("quality")
		quality_element.appendChild( newdoc.createTextNode(quality) )
		report_element.appendChild( quality_element )
		date_element = newdoc.createElement("date")
		date_element.appendChild( newdoc.createTextNode(date) )
		report_element.appendChild( date_element )
		description_element = newdoc.createElement("description")
		description_element.appendChild( newdoc.createTextNode(description) )
		report_element.appendChild( description_element )
		tags_element = newdoc.createElement("tags")
		tags_element.appendChild( newdoc.createTextNode(tags) )
		report_element.appendChild( tags_element )

		informer_element = newdoc.createElement("informer")
		report_element.appendChild( informer_element )

		uri_element = newdoc.createElement("uri")
		uri_element.appendChild( newdoc.createTextNode(uri) )
		informer_element.appendChild( uri_element )
		name_element = newdoc.createElement("name")
		name_element.appendChild( newdoc.createTextNode(name) )
		informer_element.appendChild( name_element )
		i_link_element = newdoc.createElement("link")
		i_link_element.appendChild( newdoc.createTextNode(i_link) )
		informer_element.appendChild( i_link_element )
		description_element = newdoc.createElement("description")
		description_element.appendChild( newdoc.createTextNode(i_description) )
		informer_element.appendChild( description_element )
		image_element = newdoc.createElement("image")
		image_element.appendChild( newdoc.createTextNode(image) )
		informer_element.appendChild( image_element )
		hops_element = newdoc.createElement("hops")
		hops_element.appendChild( newdoc.createTextNode(hops) )
		informer_element.appendChild( hops_element )
		visitDate_element = newdoc.createElement("visitDate")
		visitDate_element.appendChild( newdoc.createTextNode(visitDate) )
		informer_element.appendChild( visitDate_element )
		modifiedDate_element = newdoc.createElement("modifiedDate")
		modifiedDate_element.appendChild( newdoc.createTextNode(modifiedDate) )
		informer_element.appendChild( modifiedDate_element )
		failDate_element = newdoc.createElement("failDate")
		failDate_element.appendChild( newdoc.createTextNode(failDate) )
		informer_element.appendChild( failDate_element )
		comment_element = newdoc.createElement("comment")
		comment_element.appendChild( newdoc.createTextNode(comment) )
		informer_element.appendChild( comment_element )
		
	print "___MDDB:done"
	return newdoc.toxml()	