from xml.dom.minidom import getDOMImplementation
import re, urllib
import apsw
import mddb_URIstripper
import dateFormat, datetime
from random import *

global gSuzanneDateFormat
gSuzanneDateFormat = "Y-m-dTH:i:sZ"

global false, true
true = 1
false = 0


def randomURI(params, cursor, serverVars):
	print "___MDDB:Doing Random"

	# no params
		
	# setup our XML output
	impl = getDOMImplementation()
	newdoc = impl.createDocument(None, "results", None)
	results_element = newdoc.documentElement		
		
	# TODO: sort by hops of the person giving the report...
	SQL = """
		SELECT 
			R.link
		FROM
			tblInformerProfiles I,
			tblReports R LEFT OUTER JOIN tblVisitedURIs V ON R.link = V.URI
		WHERE
			R.quality > 0 
			AND	I.uri = R.informer
			AND R.isInformerStatement <> '1'
			AND R.informer <> '%s' -- Don't look at your own reports (Do we want this?)
		ORDER BY
			--I.hops, -- Fabian had the good point that you don't want to (only) see reports from people close--you already know the stuff they like. You want something exotic
			V.visitDate,
			R.date
		LIMIT
			100
		"""  % (serverVars["userURI"])
	count = 0
	randomList = []
	try:
		for x in cursor.execute(SQL):
			randomList.append(x[0])
			#print "___MDDB: Found random possibility: "+x[0]
	except apsw.MisuseError: #TODO: WTF is this non-error?
		pass
	
	print randomList
	
	URI = randomList[ randrange( len(randomList) ) ]	
	print "___MDDB: Chose URI: " + URI		
	d = datetime.datetime.now()
	df = dateFormat.DateFormat(d)
	
	SQL = """
		REPLACE INTO tblVisitedURIs 
			(URI, visitDate)
		VALUES
			('%s','%s');
		""" % (URI, df.format(gSuzanneDateFormat))
	try:
		cursor.execute(SQL)
	except apsw.MisuseError: #WTF is this non-error?
		pass

		
	uri_element = newdoc.createElement("uri")
	uri_element.appendChild( newdoc.createTextNode(URI) )
	results_element.appendChild( uri_element )
	
	return newdoc.toxml()	