from xml.dom.minidom import getDOMImplementation
import re, urllib
import apsw

global false, true
true = 1
false = 0

def recentActivity(params, cursor, serverVars):
	maxCount = 9999
	offset = 0
	showSQL = false;
	for (param,value) in params:
		if (param=="maxCount"):
			maxCount=value
		if (param=="offset"):
			offset=value
		elif (param=="SQL"):
			showSQL = true
		
	print params
	
	# setup our XML output
	impl = getDOMImplementation()
	newdoc = impl.createDocument(None, "results", None)
	results_element = newdoc.documentElement		
	
	reports_element = newdoc.createElement("reports")
	results_element.appendChild(reports_element)

	SQL = """
		SELECT 
			I.uri,
			I.name,
			I.link,
			I.description,
			I.image,
			I.hops,
			R.scope,
			R.link,
			R.isInformerStatement,
			R.quality,
			R.date,
			R.description,
			R.tags
		FROM
			tblReports R,
			tblInformerProfiles I
		WHERE
			R.informer = I.uri AND
			R.date <> ''
		ORDER BY
			R.date DESC
		LIMIT %s OFFSET %s
		"""  % (maxCount, offset)

	print SQL
	
	count = 0
	for (uri, \
		name, \
		i_link, \
		i_description, \
		image, \
		hops, \
		scope, \
		link, \
		isInformerStatement, \
		quality, \
		date, \
		description, \
		tags) \
	in cursor.execute(SQL):
		count += 1
		#print count
		
		# hack for older statements
		if not(link):
			link = scope
		
		# this is dumb. I wish I had javascript here.							
		uri=("", uri)[bool(uri)]
		name=("", name)[bool(name)]
		link=("", link)[bool(link)]
		description=("", description)[bool(description)]
		image=("", image)[bool(image)]
		hops=("", repr(hops))[bool(hops)]
		scope=("", scope)[bool(scope)]
		link=("", link)[bool(link)]
		isInformerStatement=("", isInformerStatement)[bool(isInformerStatement)]
		quality=("", quality)[bool(quality)]
		date=("", date)[bool(date)]
		description=("", description)[bool(description)]
		tags=("", tags)[bool(tags)]

		report_element = newdoc.createElement("report")
		reports_element.appendChild( report_element )

		scope_element = newdoc.createElement("scope")
		scope_element.appendChild( newdoc.createTextNode(scope) )
		report_element.appendChild( scope_element )
		link_element = newdoc.createElement("link")
		link_element.appendChild( newdoc.createTextNode(link) )
		report_element.appendChild( link_element )
		isInformerStatement_element = newdoc.createElement("isInformerStatement")
		isInformerStatement_element.appendChild( newdoc.createTextNode(isInformerStatement) )
		report_element.appendChild( isInformerStatement_element )
		quality_element = newdoc.createElement("quality")
		quality_element.appendChild( newdoc.createTextNode(quality) )
		report_element.appendChild( quality_element )
		date_element = newdoc.createElement("date")
		date_element.appendChild( newdoc.createTextNode(date) )
		report_element.appendChild( date_element )
		description_element = newdoc.createElement("description")
		description_element.appendChild( newdoc.createTextNode(description) )
		report_element.appendChild( description_element )
		tags_element = newdoc.createElement("tags")
		tags_element.appendChild( newdoc.createTextNode(tags) )
		report_element.appendChild( tags_element )

		informer_element = newdoc.createElement("informer")
		report_element.appendChild( informer_element )

		uri_element = newdoc.createElement("uri")
		uri_element.appendChild( newdoc.createTextNode(uri) )
		informer_element.appendChild( uri_element )
		name_element = newdoc.createElement("name")
		name_element.appendChild( newdoc.createTextNode(name) )
		informer_element.appendChild( name_element )
		link_element = newdoc.createElement("link")
		link_element.appendChild( newdoc.createTextNode(link) )
		informer_element.appendChild( link_element )
		description_element = newdoc.createElement("description")
		description_element.appendChild( newdoc.createTextNode(i_description) )
		informer_element.appendChild( description_element )
		image_element = newdoc.createElement("image")
		image_element.appendChild( newdoc.createTextNode(image) )
		informer_element.appendChild( image_element )
		hops_element = newdoc.createElement("hops")
		hops_element.appendChild( newdoc.createTextNode(hops) )
		informer_element.appendChild( hops_element )
		
	print "___MDDB:done"
	return newdoc.toxml()	