from xml.dom.minidom import getDOMImplementation
import apsw
import sys
import mddb_URIstripper

global false, true
true = 1
false = 0

def reset(params, cursor, serverVars):
	
	success = false
	
	# read SQL code for reset
	f = open(serverVars["base_path"]+"sql/reset.sql")
	SQL = f.read();
	f.close()
	try:
		success = true
		cursor.execute(SQL)
	except apsw.MisuseError: #TODO: WTF is this "non-error"?
		print "___MDDB: Wierd APSW error.", sys.exc_info()[0]		
		pass
	except:
		# something went wrong with out writing to database
		print "___MDDB:Problem reseting database.", sys.exc_info()[0]
		success = false
	
	# setup our XML output
	impl = getDOMImplementation()
	if (success):
		newdoc = impl.createDocument(None, "success", None)
	else:
		newdoc = impl.createDocument(None, "failure", None)
	
	return newdoc.toxml()	 