from xml.dom.minidom import getDOMImplementation
import re
import sys
import apsw

def addReport(params, cursor, serverVars):
	print "___MDDB:addReport"
	
	status = "success"
	
	# TODO: error handling, SOAP
	link = filter( (lambda (param,value) : param=="link"), params)[0]

	for (param,value) in params:
		print param,"=",value
	
	isInformerStatement = filter( (lambda (param,value) : param=="isInformerStatement"), params)[0][1]
	link                = filter( (lambda (param,value) : param=="link"), params)[0][1]
	scope               = filter( (lambda (param,value) : param=="scope"), params)[0][1]
	link                = filter( (lambda (param,value) : param=="link"), params)[0][1]
	title               = filter( (lambda (param,value) : param=="title"), params)[0][1]
	quality             = filter( (lambda (param,value) : param=="quality"), params)[0][1]
	date                = filter( (lambda (param,value) : param=="date"), params)[0][1] 
	description         = filter( (lambda (param,value) : param=="description"), params)[0][1]
	tags                = filter( (lambda (param,value) : param=="tags"), params)[0][1]
	
	# switch from latin-1 to utf-8 (TODO: how can we know what format the brower is giving data to us in?)
	title = unicode(title,'latin-1').encode('utf8')
	description = unicode(description,'latin-1') #unicode(description,'latin-1').encode('utf8')
	tags = unicode(tags,'latin-1').encode('utf8')
	
#	print params
#	print "___MDDB:--"
#	print		filter( (lambda (param,value) : param=="link"), params)[0][1]
#	print		filter( (lambda (param,value) : param=="scope"), params)[0][1]
#	print		filter( (lambda (param,value) : param=="isInformerStatement"), params)[0][1]
#	print		filter( (lambda (param,value) : param=="quality"), params)[0][1]
#	print		filter( (lambda (param,value) : param=="date"), params)[0][1]
#	print		filter( (lambda (param,value) : param=="description"), params)[0][1]
#	print		filter( (lambda (param,value) : param=="tags"), params)[0][1]
#	print "___MDDB:--"

	SQL = """
		DELETE FROM tblReports
		WHERE 
			informer = '%s' AND
			link = '%s';
			
		INSERT INTO tblReports (
			informer,
			scope,
			link,
			title,
			isInformerStatement,
			quality,
			date,
			description,
			tags)
		VALUES (?,?,?,?,?,?,?,?,?);
		""" % (serverVars["userURI"], link)
	print SQL
	try:	
		cursor.execute(SQL, (serverVars["userURI"], scope, link, title, isInformerStatement, quality, date, description, tags))
	except apsw.MisuseError: #TODO: WTF is this non-error?
		pass
	except:
		status = "FAIL"
		
#	SQL = u"""
#		DELETE FROM tblReports
#		WHERE 
#			informer = '%s' AND
#			link = '%s';
#			
#		INSERT INTO tblReports (
#			informer,
#			scope,
#			link,
#			isInformerStatement,
#			quality,
#			date,
#			description,
#			tags)
#		VALUES ('%s','%s','%s','%s','%s','%s','%s','%s');
#		""" % ( \
#			serverVars["userURI"] , \
#			filter( (lambda (param,value) : param=="link"), params)[0][1] , \
#			serverVars["userURI"] , \
#			filter( (lambda (param,value) : param=="scope"), params)[0][1] , \
#			filter( (lambda (param,value) : param=="link"), params)[0][1] , \
#			filter( (lambda (param,value) : param=="isInformerStatement"), params)[0][1] , \
#			filter( (lambda (param,value) : param=="quality"), params)[0][1] , \
#			filter( (lambda (param,value) : param=="date"), params)[0][1] , \
#			filter( (lambda (param,value) : param=="description"), params)[0][1] , \
#			filter( (lambda (param,value) : param=="tags"), params)[0][1] , \
#		)
#
#	print SQL
#	try:	
#		cursor.execute(SQL)
#	except apsw.MisuseError: #TODO: WTF is this non-error?
#		pass

#	SQL = """
#		DELETE FROM tblReports
#		WHERE 
#			informer = ? AND
#			link = ?;
#			
#		INSERT INTO tblReports (
#			informer,
#			scope,
#			link,
#			isInformerStatement,
#			quality,
#			date,
#			description,
#			tags)
#		VALUES (?,?,?,?,?,?,?,?)
#		""" 
#
#	print SQL
#	try:	
#		cursor.execute(SQL,  ( \
#			serverVars["userURI"] , \
#			unicode( filter( (lambda (param,value) : param=="link"), params)[0][1] ,'latin-1').encode('utf-8','replace'), \
#			serverVars["userURI"] , \
#			unicode( filter( (lambda (param,value) : param=="scope"), params)[0][1] ,'latin-1').encode('utf-8','replace'), \
#			unicode( filter( (lambda (param,value) : param=="link"), params)[0][1] ,'latin-1').encode('utf-8','replace'), \
#			unicode( filter( (lambda (param,value) : param=="isInformerStatement"), params)[0][1] ,'latin-1').encode('utf-8','replace'), \
#			unicode( filter( (lambda (param,value) : param=="quality"), params)[0][1] ,'latin-1').encode('utf-8','replace'), \
#			unicode( filter( (lambda (param,value) : param=="date"), params)[0][1] ,'latin-1').encode('utf-8','replace'), \
#			unicode( filter( (lambda (param,value) : param=="description"), params)[0][1] ,'latin-1').encode('utf-8','replace'), \
#			unicode( filter( (lambda (param,value) : param=="tags"), params)[0][1] ,'latin-1').encode('utf-8','replace'), \
#		))
#	except apsw.MisuseError: #TODO: WTF is this non-error?
#		pass
		
	if (isInformerStatement=="1"):
		print "___MDDB: Re-calculating HOPS"
		# if they've added an informer, we need to re-adjust our hop counts
		# read SQL code for calculating hops
		f = open(serverVars["base_path"]+"sql/hops.sql")
		hopsSQL = f.read();
		# insert user's URI into the SQL code
		p = re.compile( '_USER_URI_')
		hopsSQL = p.sub( serverVars["userURI"], hopsSQL)

		try:
			cursor.execute(hopsSQL)
		except apsw.MisuseError: #TODO: WTF is this "non-error"?
			pass
		except:
			# something went wrong with out writing to database
			print "___MDDB: Problem calculating hops.", sys.exc_info()[0]
			status = "FAIL"
	
	# setup our XML output
	impl = getDOMImplementation()
	newdoc = impl.createDocument(None, status, None)
	results_element = newdoc.documentElement		

	return newdoc.toxml()	
