from xml.dom.minidom import getDOMImplementation
import re, urllib
import apsw

global false, true
true = 1
false = 0

def getChain(params, cursor, serverVars):
	print "___MDDB:getChain"

	targetInformerURI = "";
	for (param,value) in params:
		if (param=="targetInformerURI"):
			targetInformerURI = value
			
	# setup our XML output
	impl = getDOMImplementation()
	newdoc = impl.createDocument(None, "results", None)
	results_element = newdoc.documentElement		
	
	chains_element = newdoc.createElement("chains")
	results_element.appendChild(chains_element)

	# read SQL code for getting chain between users
	f = open(serverVars["base_path"]+"sql/chain.sql")
	SQL = """
		SELECT
			hops, i1, i2, i3, i4, i5
		FROM
			tblChain C
		WHERE
			C.i1 = '%s'
		;
	""" % (targetInformerURI)
	
	chains = []
	
	try:
		for ( 
			hops, \
			uri1, \
			uri2, \
			uri3, \
			uri4, \
			uri5, \
		) \
		in cursor.execute(SQL):

			chain = []
			if hops>=1:
				chain.append(uri1)
			if hops>=2:
				chain.append(uri2)
			if hops>=3:
				chain.append(uri3)
			if hops>=4:
				chain.append(uri4)
			if hops>=5:
				chain.append(uri5)
			chain.append(serverVars["userURI"])
			chains.append(chain)
			print chain
	except apsw.MisuseError: #TODO: WTF is this non-error?
		pass
	
		
	for chain in chains:
		hops = len(chain)

		chain_element = newdoc.createElement("chain")
#		chain_element.setAttribute("hops",repr(hops))		
		chains_element.appendChild( chain_element )
		
		for informerURI in chain:
			SQL = """
			SELECT 
				I.uri,
				I.name,
				I.link,
				I.description,
				I.image,
				I.hops
			FROM
				tblInformerProfiles I
			WHERE
				I.uri = '%s'
			""" % informerURI
			for (uri, \
				name, \
				link, \
				description, \
				image, \
				hops) \
			in cursor.execute(SQL):
				print name

				# this is dumb. I wish I had javascript here.							
				uri=("", uri)[bool(uri)]
				name=("", name)[bool(name)]
				link=("", link)[bool(link)]
				description=("", description)[bool(description)]
				image=("", image)[bool(image)]
				hops=(repr(hops))

				informer_element = newdoc.createElement("informer")
				chain_element.appendChild( informer_element )

				urelement = newdoc.createElement("uri")
				urelement.appendChild( newdoc.createTextNode(uri) )
				informer_element.appendChild( urelement )

				name_element = newdoc.createElement("name")
				name_element.appendChild( newdoc.createTextNode(name) )
				informer_element.appendChild( name_element )

				link_element = newdoc.createElement("link")
				link_element.appendChild( newdoc.createTextNode(link) )
				informer_element.appendChild( link_element )

				description_element = newdoc.createElement("description")
				description_element.appendChild( newdoc.createTextNode(description) )
				informer_element.appendChild( description_element )

				image_element = newdoc.createElement("image")
				image_element.appendChild( newdoc.createTextNode(image) )
				informer_element.appendChild( image_element )
		
				hops_element = newdoc.createElement("hops")
				hops_element.appendChild( newdoc.createTextNode(hops) )
				informer_element.appendChild( hops_element )
				
	print "___MDDB:done"
	return newdoc.toxml()	