
		BEGIN;
		
	
		/* Clear out existing report */
		/* TODO: with triggers? */

		DELETE FROM tblInformerProfiles
		WHERE uri = 'http://www.trustbase.org/users/stan.xml';

		DELETE FROM tblReports
		WHERE informer = 'http://www.trustbase.org/users/stan.xml';

		DELETE FROM tblTags
		WHERE informer = 'http://www.trustbase.org/users/stan.xml';


		/* Profile info */
			
		INSERT INTO tblInformerProfiles 
			( uri, name, link, description, image, pubKey, maxPing, tags)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'Stan',
			'http://www.wanderingstan.com',
			'Hope you like Outfoxed. I like cheese.',
			'http://www.trustbase.org/users/stan.jpg',
			'',
			'',
			''			
		);
		
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*gator.com*',
			'http://www.gator.com/',
			0,
			'-50',
			'2005-01-02T23:04Z',
			'All spyware. Do not install from them.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*gatorland.com*',
			'http://www.gatorland.com/',
			0,
			'50',
			'2005-01-02T23:25Z',
			'I had fun here. Birds are cool.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*maxtor.com*',
			'http://www.maxtor.com/',
			0,
			'-25',
			'2005-01-02T23:28Z',
			'My external maxtor 160 drive died a horrible death. Epinions reports that others had the same experience.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*uni-osnabrueck.de*',
			'http://www.uni-osnabrueck.de/',
			0,
			'50',
			'2005-01-02T23:31Z',
			'My favorite school.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*dict.leo.org*',
			'http://dict.leo.org/',
			0,
			'50',
			'2005-01-03T02:33Z',
			'Great tool!'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*xulplanet.com*',
			'http://www.xulplanet.com/',
			0,
			'50',
			'2005-01-03T15:18Z',
			'Great source for XML, XSLT, XUL stuff.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*mozilla.org*',
			'http://www.mozilla.org/',
			0,
			'50',
			'2005-01-03T15:19Z',
			'Good stuff all around.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*devguru.com*',
			'http://www.devguru.com/',
			0,
			'50',
			'2005-01-03T17:06Z',
			'Ugly, but good information.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*hotbar.com*',
			'http://www.hotbar.com/',
			0,
			'-50',
			'2005-01-03T17:20Z',
			'Do not install anything from here. It´s all spyware and will mess up your computer. '
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*webhancer.com*',
			'http://www.webhancer.com/',
			0,
			'-50',
			'2005-01-03T17:21Z',
			'Whatever they say, these guys are spyware. Don´t install anything from them.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*cometcursor.com*',
			'http://www.cometcursor.com/',
			0,
			'-50',
			'2005-01-03T17:23Z',
			'Do not install anything from Comet Cursor. It is all spyware and is next to impossible to remove.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*en.wikipedia.org*',
			'http://en.wikipedia.org/',
			0,
			'50',
			'2005-01-03T17:25Z',
			'Lots of information. Not all of it is accurate, but a good place to get started with research.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*180solutions.com*',
			'http://www.180solutions.com/',
			0,
			'-50',
			'2005-01-03T17:26Z',
			'Spyware company. Stay away.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*direct-revenue.com*',
			'http://www.direct-revenue.com/about.asp',
			0,
			'-50',
			'2005-01-03T17:27Z',
			'All spyware. Stay away.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*bonzi.com*',
			'http://www.bonzi.com/',
			0,
			'-50',
			'2005-01-03T17:28Z',
			'Spyware. Do NOT install anything from this site. Impossible to remove.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*claria.com*',
			'http://www.claria.com/',
			0,
			'-50',
			'2005-01-03T17:29Z',
			'All spyware. Used to be called Gator.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*coolwebsearch.com*',
			'http://www.coolwebsearch.com/',
			0,
			'-50',
			'2005-01-03T17:31Z',
			'All spyware. If you see this page all the time, you´ve been infected. Ask for help.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*shopathomeselect.com*',
			'http://www.shopathomeselect.com/',
			0,
			'-50',
			'2005-01-03T17:32Z',
			'Spyware. Don´t install anything. If you see this page all the time, you´ve been infected.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*nuker.com*',
			'http://www.nuker.com/',
			0,
			'-50',
			'2005-01-03T17:34Z',
			'This software will no remove spyware, IT IS SPYWARE. Do not install. '
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://xulplanet.mozdev.org/references/elemref/ref_deck.html',
			'http://xulplanet.mozdev.org/references/elemref/ref_deck.html',
			0,
			'50',
			'2005-01-03T18:29Z',
			'Good.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*webreference.com*',
			'http://www.webreference.com/',
			0,
			'50',
			'2005-01-05T11:18Z',
			'Good HTML, Javascript, CSS stuff.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'md5://f2cc748607c48ff932b9032ecd3c0d55',
			'md5://f2cc748607c48ff932b9032ecd3c0d55',
			0,
			'50',
			'2005-01-05T13:57Z',
			'AlphaTicker Extension'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*kb.mozillazine.org*',
			'http://kb.mozillazine.org/',
			0,
			'50',
			'2005-01-05T14:43Z',
			'Good Javascript/Mozilla info'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/goedel.xml',
			'http://www.trustbase.org/users/goedel.xml',
			0,
			'50',
			'2005-01-05T23:49Z',
			'He´s the man.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*onion.com*',
			'http://www.onion.com/',
			0,
			'50',
			'2005-01-06T08:52Z',
			'Best satire ever.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://wakaba.nervalhi.net/mods/src/everyonehashadmoresex.swf',
			'http://wakaba.nervalhi.net/mods/src/everyonehashadmoresex.swf',
			0,
			'50',
			'2005-01-06T08:57Z',
			'good video'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*studip.rz.uni-osnabrueck.de*',
			'https://studip.rz.uni-osnabrueck.de/',
			0,
			'50',
			'2005-01-06T10:12Z',
			'It´s my uni.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*wanderingstan.com*',
			'http://www.wanderingstan.com/index.htm',
			0,
			'50',
			'2005-01-06T13:13Z',
			'The best!'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*transactionjunction.com*',
			'http://www.transactionjunction.com/',
			0,
			'-25',
			'2005-01-06T13:23Z',
			'Sketch. Spam link. If you want music, consider http://www.emule-project.net or http://www.limewire.com.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*transactionjunction.com*',
			'http://www.transactionjunction.com/news.html',
			0,
			'-25',
			'2005-01-06T13:24Z',
			'Spamlink. Sketchy. If you want music, try http://www.limewire.com or http://www.emule-project.net'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*nonviolence.org*',
			'http://www.nonviolence.org/',
			0,
			'50',
			'2005-01-06T15:03Z',
			'okay...'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'md5://a681c6a002989832645ed26b766c7afa',
			'md5://a681c6a002989832645ed26b766c7afa',
			0,
			'50',
			'2005-01-06T15:05Z',
			'Cool extension.
'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*signal42.com*',
			'http://www.signal42.com/javascript_substring.asp',
			0,
			'-25',
			'2005-01-07T11:53Z',
			'Just advertisements.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*monkeyfilter.com*',
			'http://www.monkeyfilter.com/',
			0,
			'50',
			'2005-01-11T23:04Z',
			'Great source for links. See http://www.metafilter.com too.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/koenigb.xml',
			'http://www.trustbase.org/users/koenigb.xml',
			0,
			'50',
			'2005-01-15T17:13Z',
			'Cool guy.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*superstructs.com*',
			'http://www.superstructs.com/',
			0,
			'50',
			'2005-01-15T21:19Z',
			'Great toys.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'sha1://3aa6f328e7b62d7ac606fda4b4347c6b1e2e4504',
			'sha1://3aa6f328e7b62d7ac606fda4b4347c6b1e2e4504',
			0,
			'50',
			'2005-01-20T00:07Z',
			'good.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.macromedia.com/shockwave/download/download.cgi?P1_Prod_Version=ShockwaveFlash',
			'http://www.macromedia.com/shockwave/download/download.cgi?P1_Prod_Version=ShockwaveFlash',
			0,
			'50',
			'2005-01-20T15:10Z',
			'Flash player is ok. To avoid flash ads, use FlashBlock: http://flashblock.mozdev.org/installation.html'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*poplockin.com*',
			'http://www.poplockin.com/',
			0,
			'50',
			'2005-01-21T19:08Z',
			''
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*exeem.com*',
			'http://www.exeem.com/',
			0,
			'-50',
			'2005-01-22T13:59Z',
			'eXeem includes cydoor spyware. Use http://www.exlite.net/ for a spyware-free version.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*paulgraham.com*',
			'http://paulgraham.com/hs.html',
			0,
			'50',
			'2005-01-22T17:18Z',
			'Nice speech.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*old-computers.com*',
			'http://www.old-computers.com/',
			0,
			'50',
			'2005-01-23T15:27Z',
			'Nostalgia'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*pcpitstop.com*',
			'http://www.pcpitstop.com/',
			0,
			'50',
			'2005-01-23T22:54Z',
			'Good anti-spyware info.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*thinkcoxisch.de*',
			'http://www.thinkcoxisch.de/',
			0,
			'50',
			'2005-01-24',
			'Good freeware and such, filtered by a Osn Cogsci friend of mine.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*geocities.jp*',
			'http://www.geocities.jp/',
			0,
			'50',
			'2005-01-24',
			''
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*trustbase.org*',
			'http://www.trustbase.org/',
			0,
			'50',
			'2005-01-25',
			'This is the testing zone for the Outfoxed beta. Yeah, at one point the project was called "trustbase," but I like the new name better. But "outfoxed.com" costs 50,000 euros...'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.myfonts.com/WhatTheFont/',
			'http://www.myfonts.com/WhatTheFont/',
			0,
			'50',
			'2005-01-25',
			'Great tool-- you send it an image of text, and it tells you what font it is.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*koders.com*',
			'http://www.koders.com/',
			0,
			'50',
			'2005-01-25',
			'It´s like a google, but for code.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*del.icio.us*',
			'http://del.icio.us/',
			0,
			'50',
			'2005-01-25',
			'Very similar to outfoxed...but different.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*johnny.ihackstuff.com*',
			'http://johnny.ihackstuff.com/',
			0,
			'50',
			'2005-01-25',
			'Google hacking is cool.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*cydoor.com*',
			'http://www.cydoor.com/',
			0,
			'-50',
			'2005-01-25',
			'It´s another spyware company. Don´t install anything from these guys.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.geocities.jp/andromedagalaxis/',
			'http://www.geocities.jp/andromedagalaxis/',
			0,
			'50',
			'2005-01-25',
			'Mayumi is cool.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*doik.de*',
			'http://www.doik.de/',
			0,
			'50',
			'2005-01-25',
			'Coxi guy.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*urbandictionary.com*',
			'http://www.urbandictionary.com/',
			0,
			'50',
			'2005-01-25',
			'fo shizzle ma nizzle - 
a bastardization of "fo´ sheezy mah neezy" which is a bastardization of "for sure mah nigga" which is a bastdardization of "I concur with you whole heartedly my African american brother."'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*colorado.edu*',
			'http://www.colorado.edu/',
			0,
			'50',
			'2005-01-26',
			'My old university!'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*javascriptkit.com*',
			'http://www.javascriptkit.com/',
			0,
			'-25',
			'2005-01-27',
			'Horrible pop-ups. Even in firefox.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*20q.com*',
			'http://www.20q.com/',
			0,
			'50',
			'2005-02-03',
			'Hours of fun.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'process://Win32/System',
			'process://Win32/System',
			0,
			'50',
			'2005-02-03',
			''
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'process://Win32/winlogon.exe',
			'process://Win32/winlogon.exe',
			0,
			'50',
			'2005-02-03',
			'It´s okay.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'process://Win32/cmd.exe',
			'process://Win32/cmd.exe',
			0,
			'50',
			'2005-02-03',
			'It´s just the command line interface.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'process://Win32/System%20Idle%20Process',
			'process://Win32/System%20Idle%20Process',
			0,
			'50',
			'2005-02-03',
			'It´s my favorite program!'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*gainpublishing.com*',
			'http://www.gainpublishing.com/',
			0,
			'-50',
			'2005-02-04',
			'Spyware, just like http://www.gator.com'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*dashbar.com*',
			'http://www.dashbar.com/',
			0,
			'-50',
			'2005-02-04',
			'Spyware. It´s from http://www.claria.com (aka Gator)'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*weatherscope.com*',
			'http://www.weatherscope.com/',
			0,
			'-50',
			'2005-02-04',
			'Spyware. It´s from http://www.claria.com (aka Gator)'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*precision-time.com*',
			'http://www.precision-time.com/',
			0,
			'-50',
			'2005-02-04',
			'Spyware. It´s from http://www.claria.com (aka Gator)'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*gainnetwork.net*',
			'http://www.gainnetwork.net/',
			0,
			'-50',
			'2005-02-04',
			'Spyware. It´s from http://www.claria.com (aka Gator)'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*offercompanion.com*',
			'http://www.offercompanion.com/',
			0,
			'-50',
			'2005-02-04',
			'Spyware. It´s from http://www.claria.com (aka Gator)'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*date-manager.com*',
			'http://www.date-manager.com/',
			0,
			'-50',
			'2005-02-04',
			'Spyware. It´s from http://www.claria.com (aka Gator)'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*websecurealert.com*',
			'http://www.websecurealert.com/',
			0,
			'-50',
			'2005-02-04',
			'Spyware. It´s from http://www.claria.com (aka Gator)'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*entrypass.com*',
			'http://www.entrypass.com/',
			0,
			'-50',
			'2005-02-04',
			'Spyware. It´s from http://www.claria.com (aka Gator)'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*searchscout.com*',
			'http://www.searchscout.com/',
			0,
			'-50',
			'2005-02-04',
			'Spyware. It´s from http://www.claria.com (aka Gator)'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*screenscenes.com*',
			'http://www.screenscenes.com/',
			0,
			'-50',
			'2005-02-04',
			'Spyware. It´s from http://www.claria.com (aka Gator)'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'process://Win32/winamp.exe',
			'process://Win32/winamp.exe',
			0,
			'50',
			'2005-02-04',
			'Winamp is cool.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'process://Win32/ChkMail.exe',
			'process://Win32/ChkMail.exe',
			0,
			'50',
			'2005-02-04',
			'It´s the dumb mail-checking program for Acer Laptops. The progam barely works, but it does it´s job.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'process://Win32/firefox.exe',
			'process://Win32/firefox.exe',
			0,
			'50',
			'2005-02-04',
			'It´s the firefox browser. Of course it´s good.'
		);			
			
  			
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*wanderingstan.com*',
			'http://www.wanderingstan.com/',
			0,
			'50',
			'2005-02-04',
			'Yeah!'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'stan',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*wanderingstan.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'outfoxed',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*wanderingstan.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'wandering',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*wanderingstan.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'cool',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*wanderingstan.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*wired.com*',
			'http://www.wired.com/',
			0,
			'50',
			'2005-02-04',
			'Interesting tech news'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'technology',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*wired.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'internet',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*wired.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'news',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*wired.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*imdb.com*',
			'http://www.imdb.com/',
			0,
			'50',
			'2005-02-05',
			'Good.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*imdb.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*w3.org*',
			'http://www.w3.org/',
			0,
			'50',
			'2005-02-06',
			'The internet standards people.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'web',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*w3.org*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'standards',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*w3.org*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'uri',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*w3.org*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'url',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*w3.org*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'xml',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*w3.org*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'rdf',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*w3.org*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*wonderingcogsci.blogspot.com*',
			'http://wonderingcogsci.blogspot.com/',
			0,
			'50',
			'2005-02-06',
			'It´s Caryn´s blog!'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'caryn',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*wonderingcogsci.blogspot.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'blog',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*wonderingcogsci.blogspot.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'cogsci',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*wonderingcogsci.blogspot.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'process://Win32/TextPad.exe',
			'process://Win32/TextPad.exe',
			0,
			'50',
			'2005-02-06',
			'It´s my favorite text editor.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'process://Win32/TextPad.exe'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'process://Win32/Tablet.exe',
			'process://Win32/Tablet.exe',
			0,
			'50',
			'2005-02-06',
			'Something for the Windows XP Tablet edition.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'process://Win32/Tablet.exe'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'process://Win32/svchost.exe',
			'process://Win32/svchost.exe',
			0,
			'50',
			'2005-02-06',
			'OK.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'process://Win32/svchost.exe'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*hindustantimes.com*',
			'http://www.hindustantimes.com/',
			0,
			'-25',
			'2005-02-06',
			'Annoying pop-ups, even in FIrefox.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*hindustantimes.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'process://Win32/explorer.exe',
			'process://Win32/explorer.exe',
			0,
			'50',
			'2005-02-06',
			'Well, it´s "good" as in "not evil", but not "good" as in "high quality". '
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'process://Win32/explorer.exe'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.timkietzmann.de/disco/',
			'http://www.timkietzmann.de/disco/',
			0,
			'50',
			'2005-02-06',
			'Ultimate Frisbee Osnabruek!'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'ultimate',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.timkietzmann.de/disco/'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'frisbee',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.timkietzmann.de/disco/'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'osnabrueck',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.timkietzmann.de/disco/'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*kunstparker.de*',
			'http://kunstparker.de/',
			0,
			'50',
			'2005-02-07T16:58Z',
			'Galery of bad parking.(German)'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'funny',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*kunstparker.de*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'parking',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*kunstparker.de*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'germany',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*kunstparker.de*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'pictures',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*kunstparker.de*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'galery',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*kunstparker.de*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*mcfit.de*',
			'http://www.mcfit.de/',
			0,
			'50',
			'2005-02-07T17:16Z',
			'My gym. Cheap. Bad music. Open 24 hours. What more could you want?'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'osnabrueck',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*mcfit.de*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'fitness',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*mcfit.de*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'gym',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*mcfit.de*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*rule110.org*',
			'http://www.rule110.org/',
			0,
			'50',
			'2005-02-08T10:56Z',
			'Articificial Life is cool. Even cooler in Osnabruek.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'alife',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*rule110.org*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'osnabrueck',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*rule110.org*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'wolfram',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*rule110.org*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'110',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*rule110.org*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'germany',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*rule110.org*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'evolution',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*rule110.org*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'sha1://57ad89a45002c492eb0b6bbcdb781cb97cedb431',
			'sha1://57ad89a45002c492eb0b6bbcdb781cb97cedb431',
			0,
			'50',
			'2005-02-08T11:18Z',
			'Outfoxed Beta, version 025.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'sha1://57ad89a45002c492eb0b6bbcdb781cb97cedb431'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*whatsbetter.com*',
			'http://www.whatsbetter.com/',
			0,
			'50',
			'2005-02-08T16:09Z',
			'What´s better? You decide.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'timewasting',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*whatsbetter.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'fun',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*whatsbetter.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*cliona.yayhooray.com*',
			'http://cliona.yayhooray.com/',
			0,
			'50',
			'2005-02-08T23:20Z',
			'Cliona´s blog!'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'blog',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*cliona.yayhooray.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'cliona',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*cliona.yayhooray.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*der-mo.net*',
			'http://der-mo.net/',
			0,
			'50',
			'2005-02-08T23:21Z',
			'Cool stuff. Moritz´s page.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'cogsci',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*der-mo.net*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'flash',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*der-mo.net*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'feelspace',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*der-mo.net*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'hci',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*der-mo.net*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'perception',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*der-mo.net*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'osnabrueck',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*der-mo.net*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://der-mo.net/WINDS/index.html',
			'http://der-mo.net/WINDS/index.html',
			0,
			'50',
			'2005-02-08T23:23Z',
			'Flash exploration of CIA world factbook'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'flash',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://der-mo.net/WINDS/index.html'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'cia',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://der-mo.net/WINDS/index.html'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'geography',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://der-mo.net/WINDS/index.html'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'graph',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://der-mo.net/WINDS/index.html'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*barlow.typepad.com*',
			'http://barlow.typepad.com/',
			0,
			'50',
			'2005-02-08T23:24Z',
			'John Barlow´s Blog. Grateful Dead and EFF guy.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'blog',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*barlow.typepad.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'EFF',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*barlow.typepad.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'politics',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*barlow.typepad.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*isketch.net*',
			'http://www.isketch.net/isketch.shtml',
			0,
			'50',
			'2005-02-08T23:26Z',
			'Fun online game. Like pictionary. (Requires Shockwave)'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'game',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*isketch.net*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'interactive',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*isketch.net*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*coversproject.com*',
			'http://www.coversproject.com/',
			0,
			'50',
			'2005-02-08T23:28Z',
			'Database of cover songs. Who has sung whose songs?'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'music',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*coversproject.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'cover',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*coversproject.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*coversproject.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*technorati.com*',
			'http://www.technorati.com/',
			0,
			'50',
			'2005-02-08T23:29Z',
			'A tagging search engine. (This is what the "keywords" section in the report box is for!) Search through tagged blogs, image galleries, and more.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'tags',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*technorati.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'blogs',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*technorati.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'search',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*technorati.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*affect.media.mit.edu*',
			'http://affect.media.mit.edu/',
			0,
			'50',
			'2005-02-09T19:06Z',
			''
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*affect.media.mit.edu*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www-csli.stanford.edu/~john/procrastination.html',
			'http://www-csli.stanford.edu/~john/procrastination.html',
			0,
			'50',
			'2005-02-11T16:12Z',
			'Great essay on how to use procrastination for good.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'essay',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www-csli.stanford.edu/~john/procrastination.html'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'procrastination',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www-csli.stanford.edu/~john/procrastination.html'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*wpn.enet.de*',
			'http://wpn.enet.de/',
			0,
			'-25',
			'2005-02-11T23:13Z',
			'Popup ad from IMDB. Blah.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*wpn.enet.de*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*evernightgame.com*',
			'http://www.evernightgame.com/',
			0,
			'50',
			'2005-02-13T18:59Z',
			'Cool game I designed, once upon a time in a galaxy far far away.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'game',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*evernightgame.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'multiplayer',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*evernightgame.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'online',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*evernightgame.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'evernight',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*evernightgame.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*metafilter.com*',
			'http://www.metafilter.com/',
			0,
			'50',
			'2005-02-13T20:48Z',
			'Good source for latest cool links. See http://www.monkeyfilter.com also.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'links',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*metafilter.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'fun',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*metafilter.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'timewasting',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*metafilter.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'blog',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*metafilter.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*oldversion.com*',
			'http://www.oldversion.com/',
			0,
			'50',
			'2005-02-16T11:35Z',
			'Get older versions of programs.  (I was happy to find an old version of Acrobat -- the new one is such a memory hog.)'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'download',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*oldversion.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'old',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*oldversion.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'version',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*oldversion.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'software',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*oldversion.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.eggheadcafe.com/index/JavaScript_slice_2d65aa1f-bf64-41dd-af62-1703cba34e0c.asp',
			'http://www.eggheadcafe.com/index/JavaScript_slice_2d65aa1f-bf64-41dd-af62-1703cba34e0c.asp',
			0,
			'-25',
			'2005-02-16T21:56Z',
			'Dump meta-search page. (Found while searching for "javascript slice")'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.eggheadcafe.com/index/JavaScript_slice_2d65aa1f-bf64-41dd-af62-1703cba34e0c.asp'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.lowmorale.co.uk/creep/flash/lm_creep_(FLASH).swf',
			'http://www.lowmorale.co.uk/creep/flash/lm_creep_(FLASH).swf',
			0,
			'50',
			'2005-02-17T21:06Z',
			'Flash video for Radiohead "Creep"'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'flash',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.lowmorale.co.uk/creep/flash/lm_creep_(FLASH).swf'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'radiohead',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.lowmorale.co.uk/creep/flash/lm_creep_(FLASH).swf'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'creep',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.lowmorale.co.uk/creep/flash/lm_creep_(FLASH).swf'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'fun',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.lowmorale.co.uk/creep/flash/lm_creep_(FLASH).swf'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.udargo.com/burton/MTV/',
			'http://www.udargo.com/burton/MTV/',
			0,
			'50',
			'2005-02-17T21:13Z',
			'Funny if you remember GnR...'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'gnr',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.udargo.com/burton/MTV/'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'mtv',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.udargo.com/burton/MTV/'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'slash',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.udargo.com/burton/MTV/'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'november',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.udargo.com/burton/MTV/'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'rain',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://www.udargo.com/burton/MTV/'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://home.comcast.net/~angelalb/ledbetter.swf',
			'http://home.comcast.net/~angelalb/ledbetter.swf',
			0,
			'50',
			'2005-03-04T16:47:15Z',
			'Explanation of Pearl Jam song.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'funny',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://home.comcast.net/~angelalb/ledbetter.swf'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'flash',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://home.comcast.net/~angelalb/ledbetter.swf'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'http://home.comcast.net/~angelalb/ledbetter.swf'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*eggheadcafe.com*',
			'http://www.eggheadcafe.com/',
			0,
			'-25',
			'2005-03-11T17:26:33Z',
			'Dumb meta-search page. (Found while searching for "javascript slice")'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*eggheadcafe.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*quixtarfacts.com*',
			'http://www.quixtarfacts.com/',
			0,
			'-25',
			'2005-03-13T16:17:58Z',
			'It´s <a href="http://www.amway.com">Amway</a>.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*quixtarfacts.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*google.com*',
			'http://www.google.com/',
			0,
			'50',
			'2005-03-14T11:59:47Z',
			'Good. To be.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*google.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'sha-1://57ad89a45002c492eb0b6bbcdb781cb97cedb431',
			'sha-1://57ad89a45002c492eb0b6bbcdb781cb97cedb431',
			0,
			'50',
			'2005-03-18T18:17:33Z',
			'It´s an old outfoxed beta.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'sha-1://57ad89a45002c492eb0b6bbcdb781cb97cedb431'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*spywarewarrior.com*',
			'http://www.spywarewarrior.com/',
			0,
			'50',
			'2005-03-19T18:45:55Z',
			'Good source of Spyware information.'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'spyware',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*spywarewarrior.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*sqlite.org*',
			'http://www.sqlite.org/',
			0,
			'50',
			'2005-03-19T23:50:58Z',
			'Cool little DB>'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'sql',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*sqlite.org*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'database',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*sqlite.org*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'*rogerbinns.com*',
			'http://www.rogerbinns.com/apsw.html',
			0,
			'50',
			'2005-03-20T08:28:17Z',
			'Good python info'
		);			
			
  			
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'python',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*rogerbinns.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'sqlite',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*rogerbinns.com*'
			);
	    	
	      
	    	INSERT INTO tblTags 
	    		(tag,degree,informer,target)
	    	VALUES
	    	(
				'code',
				100,
				'http://www.trustbase.org/users/stan.xml',
				'*rogerbinns.com*'
			);	      
	    
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.livejournal.com/userinfo.bml?user=wanderingstan',
			'',
			1,
			'',
			'2005-01-06T23:02Z',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/koenigb.xml',
			'',
			1,
			'',
			'',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/ghandi.xml',
			'',
			1,
			'',
			'',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/goedel.xml',
			'',
			1,
			'',
			'2005-01-06T02:00Z',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/pcpitstop.xml',
			'',
			1,
			'',
			'2005-01-15T17:14Z',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/mario.xml',
			'',
			1,
			'',
			'2005-01-20T01:32Z',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/step.xml',
			'',
			1,
			'',
			'2005-01-20T11:21Z',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/fabian.xml',
			'',
			1,
			'',
			'2005-01-24',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/sven.xml',
			'',
			1,
			'',
			'2005-01-25',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/joscha.xml',
			'',
			1,
			'',
			'2005-01-26',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.doik.de/Dominik.xml',
			'',
			1,
			'',
			'2005-01-27',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://dfdf.df.com/df',
			'',
			1,
			'',
			'2005-02-04',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/mo.xml',
			'',
			1,
			'',
			'2005-02-06',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://http://www.trustbase.org/users/sven.xml',
			'',
			1,
			'',
			'2005-02-06',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/beta2/omer.xml',
			'',
			1,
			'',
			'2005-02-08T16:06Z',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/beta2/caryn.xml',
			'',
			1,
			'',
			'2005-02-08T16:07Z',
			''
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/abe.xml',
			'',
			1,
			'',
			'2005-03-14T19:47:21Z',
			'He´s not honest.'
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/merlin.xml',
			'',
			1,
			'',
			'2005-03-14T22:25:48Z',
			'hi'
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.thinkcoxisch.de/markus.xml',
			'',
			1,
			'',
			'2005-03-15T11:06:08Z',
			'Okay.'
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/419all.xml',
			'',
			1,
			'',
			'2005-03-15T12:08:48Z',
			'Cool site of fake bank sites.'
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://www.trustbase.org/users/spywarewarrior.xml',
			'',
			1,
			'',
			'2005-03-16T10:27:11Z',
			'Added via web link'
		);			
	
		INSERT INTO tblReports
			(informer,target,link,isInformerStatement,quality,date,description)
		VALUES
		(
			'http://www.trustbase.org/users/stan.xml',
			'http://getoutfoxed.com/cms/firstinformeradded',
			'',
			1,
			'',
			'2005-03-18T15:05:22Z',
			'[Added via web link]'
		);			
	
		COMMIT;
	
